<?php

namespace App\Livewire\Studio\Catalog\Bottle;

use App\Enums\AuditStockStatus;
use App\Models\Bottle;
use App\Models\Outlet;
use Illuminate\Contracts\View\View;
use Illuminate\Database\Eloquent\Collection;
use Livewire\Attributes\Title;
use Livewire\Component;
use Spatie\Activitylog\Models\Activity;

#[Title('Audit')]
class Audit extends Component
{
    public string $label;

    public Collection $activityLogs;

    public function mount(Outlet $outlet, Bottle $bottle): void
    {
        $this->label = $bottle->name.' di '.$outlet->name;

        $this->activityLogs = Activity::where('subject_type', get_class($bottle))
            ->where('subject_id', $bottle->id)
            ->where('properties->outlet_id', $outlet->id)
            ->latest()
            ->get()
            ->map(function (Activity $activity) {
                $activity->event = [
                    'label' => $activity->event,
                    'color' => AuditStockStatus::from($activity->event)->color(),
                ];

                return $activity;
            });
    }

    public function render(): View
    {
        return view('components.sections.ui.audit', [
            'pageTitle' => 'Audit '.$this->label,
            'module' => 'bottle',
        ]);
    }
}
